# -*- mode: ruby -*-
# vi: set ft=ruby :

## Run this first
#vagrant plugin install vagrant-vbguest --plugin-version 0.21

Vagrant.configure("2") do |config|
  
  # Vagrant config
  config.vagrant.plugins = {"vagrant-vbguest" => {"version" => "0.21.0"}}
  config.vagrant.plugins = [ "vagrant-timezone", "vagrant-ansible-local", "vagrant-disksize", "vagrant-auto_network" ]
  # config.vagrant.sensitive = ["MySecretPassword", ENV["MY_TOKEN"]]
  
  config.vm.define "centos7" do |web|
    config.vm.box = "centos/7"
    config.vm.box_check_update = false
    
    # VM Changes
    # config.disksize.size = '50GB'
    # config.vm.boot_timeout = 300
    config.vm.usable_port_range = 2200..2250
    # config.vm.synced_folder  "./data", "/data"
    config.vm.synced_folder  "./scripts", "/scripts"
    config.vm.provider "virtualbox" do |vb|
      # vb.customize ["modifyvm", :id, "--groups", "/wd"]
      vb.name = "centos7"
      vb.check_guest_additions = true
      vb.memory = 1024
      vb.cpus = 2
      vb.customize ["modifyvm", :id, "--vram", "12"]
      vb.customize ['modifyvm', :id, '--graphicscontroller', 'vmsvga']
      vb.customize ['modifyvm', :id, '--clipboard', 'bidirectional']
    end
    config.vm.network "forwarded_port", guest: 80, host: 8080
    config.vm.network "private_network", :auto_network => true
    # config.vm.network "public_network", bridge: "Intel(R) Dual Band Wireless-AC 3165"
    # config.vm.guest = :linux
    # config.vm.graceful_halt_timeout = 60
    config.vm.communicator = "ssh"
    config.timezone.value = "Asia/Kolkata"
    #TODO: Add box description
    
    # SSH config
    # config.ssh.verify_host_key = ":always"
    # config.ssh.username = "vagrant"
    # config.ssh.remote_user = "vagrant"
    # config.ssh.sudo_command = "sudo -E -H %c"
    # config.ssh.shell = "bash -l"
    # config.ssh.port = 22
    # config.ssh.keys_only = true
    # config.ssh.insert_key = true
    # config.ssh.forward_x11 = true
    # config.ssh.connect_timeout = 15
    # config.ssh.compression = true
    

    # OS changes
    config.vm.allow_fstab_modification = true
    config.vm.allow_hosts_modification = true
    # config.vm.provision "shell", path: "scripts/setup.sh"
    # config.vm.provision :ansibleLocal, :playbook => "scripts/playbook.yml", :raw_arguments => "-i 'localhost,'"
    config.vm.hostname = "workstation"

    config.vm.post_up_message = <<-MESSAGE
      All done!
      You now have a centos7 VM running within vagrant.
      Voilaa!!
    MESSAGE
  end

end
